/////////////////////////////////////////////////////////////////////////////
// BreakpointClearDlg.c

#include "Windows.h"
#include "GdiExample.h"

BOOL CALLBACK BreakpointClearDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								     LPARAM lParam)
{
    HWND hwndList;
    int i;
    char szTemp[20];
    int nSel;
    DiReturnT fRet;

	switch (uMsg)
	{
	case WM_INITDIALOG:
	
        if (!g_nBreakpoints)
            EnableWindow(GetDlgItem(hDlg, IDC_CLEAR), FALSE);
        else
        {
            // Add breakpoints to list
            hwndList = GetDlgItem(hDlg, IDC_BREAKPOINTS);
            for (i = 0; i < g_nBreakpoints; i++)
            {
                itoa(g_breakpoints[i].nAddress, szTemp, 16);
                SendMessage(hwndList, LB_ADDSTRING, 0, (LPARAM) szTemp);
            }

            SendMessage(hwndList, LB_SETCURSEL, 0, 0);
        }

		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_CLEAR:

            // Get selected breakpoint
            hwndList = GetDlgItem(hDlg, IDC_BREAKPOINTS);
            nSel = SendMessage(hwndList, LB_GETCURSEL, 0, 0);
            if (nSel == LB_ERR)
            {
                MessageBeep((UINT)(-1));
                return FALSE;
            }

            // Clear the selected breakpoint
            ASSERT(nSel < g_nBreakpoints);
            fRet = DiBreakpointClear(g_breakpoints[nSel].nID);
            if (fRet != DI_OK)
            {
                MessageBox(NULL, "Breakpoint clear failed.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            // Delete selected breakpoint from global breakpoint list
            for (i = nSel; i < g_nBreakpoints; i++)
                g_breakpoints[i] = g_breakpoints[i + 1];
            g_nBreakpoints--;

            // Delete breakpoint from list
            SendMessage(hwndList, LB_DELETESTRING, nSel, 0);

            return TRUE;

		case IDC_CLOSE:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
