/////////////////////////////////////////////////////////////////////////////
// BreakpointSetDlg.c

#include "Windows.h"
#include "GdiExample.h"

BOOL CALLBACK BreakpointSetDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								LPARAM lParam)
{
    DiReturnT fRet;
    char szTemp[20];
    int nTemp;
    DiBpT bp;
    DiBpResultT bpID;

	switch (uMsg)
	{
	case WM_INITDIALOG:

        if (g_nBreakpoints >= MAX_NUM_BREAKPOINTS)
        {
            MessageBox(NULL, "Breakpoint list is full.", "Set Breakpoint", MB_OK);
            EndDialog(hDlg, 0);
        }

        SetDlgItemText(hDlg, IDC_ADDRESS, "0");
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:

            // CODE memory space
            bp.u.exe.daBp.dmsMemSpace = CODE_ID;

            // Scan address from edit field
            GetDlgItemText(hDlg, IDC_ADDRESS, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &nTemp) != 1)
            {
                MessageBox(NULL, "Invalid address.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            DISETVALUE32(bp.u.exe.daBp.dlaLinAddress.v, nTemp);

            bp.dbtBpType = DI_BPT_EXECUTE;
            fRet = DiBreakpointSet(&bpID, bp);
            if (fRet != DI_OK)
            {
                MessageBox(NULL, "Breakpoint set command failed.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            // Store breakpoint info in global table
            g_breakpoints[g_nBreakpoints].nAddress = nTemp;
            g_breakpoints[g_nBreakpoints].nID = bpID.dnBpId;
            g_nBreakpoints++;

            // Fall through           

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
