/////////////////////////////////////////////////////////////////////////////
// GdiExample.h

#include "GdiUser.h"
#include <assert.h>
#include <stdio.h>

#define ASSERT assert

extern HWND g_hMainWnd;

#define MAX_NUM_OUTPUT_LINES 32
extern char* g_outputLines[MAX_NUM_OUTPUT_LINES];
extern void FreeOutputLines();

#define PC_ID   0
#define CODE_ID 0

#define EMUL_DLL_NAME "emul196.dll"
#define NUM_REGISTERS 10
#define NUM_MEMORY_SPACES 8

extern DiRegisterInfoT g_registers[];
extern DiMemorySpaceInfoT g_memorySpaces[];

typedef struct
{
    int nID;
    int nAddress;

} BreakpointInfo;

#define MAX_NUM_BREAKPOINTS 8
extern BreakpointInfo g_breakpoints[];
extern int g_nBreakpoints;

extern BOOL CALLBACK MemoryReadDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK MemoryWriteDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK MemoryWriteDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK RegisterReadDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK RegisterWriteDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK RunContinueUntilDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK RunStepDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK BreakpointSetDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK BreakpointClearDlgProc(HWND, UINT, WPARAM, LPARAM);
extern BOOL CALLBACK HelpAboutDlgProc(HWND, UINT, WPARAM, LPARAM);

#include "Resource.h"
