/////////////////////////////////////////////////////////////////////////////
// MemoryWriteDlg.c

#include "Windows.h"
#include "GdiExample.h"

// In MemoryReadDlg.c
extern int g_nMemAddress;
extern int g_nMemSel;
static int g_nMemValue = 0;

BOOL CALLBACK MemoryWriteDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								 LPARAM lParam)
{
    HWND hwndList;
    int i;
    DiReturnT fRet;
    char szTemp[20];
    DiAddrT address;
    DiMemValueT value;

	switch (uMsg)
	{
	case WM_INITDIALOG:

        // Populate memory space list
        hwndList = GetDlgItem(hDlg, IDC_MEMORY_SPACE);
        for (i = 0; i < NUM_MEMORY_SPACES; i++)
            SendMessage(hwndList, CB_ADDSTRING, 0, (LPARAM) g_memorySpaces[i].szMemSpaceName);
        SendMessage(hwndList, CB_SETCURSEL, g_nMemSel, 0);       

        // Initialize controls
        itoa(g_nMemAddress, szTemp, 16);
        SetDlgItemText(hDlg, IDC_ADDRESS, szTemp);
        itoa(g_nMemValue, szTemp, 16);
        SetDlgItemText(hDlg, IDC_VALUE, szTemp);
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_WRITE:

            // Get current selection in memory space list
            hwndList = GetDlgItem(hDlg, IDC_MEMORY_SPACE);
            g_nMemSel = SendMessage(hwndList, CB_GETCURSEL, 0, 0);
            if (g_nMemSel == CB_ERR)
                return FALSE;

            // Map list index to memory space ID
            ASSERT(g_nMemSel < NUM_MEMORY_SPACES);
            address.dmsMemSpace = g_memorySpaces[g_nMemSel].dnMemSpaceId;

            // Scan address from edit field
            GetDlgItemText(hDlg, IDC_ADDRESS, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &g_nMemAddress) != 1)
            {
                MessageBox(NULL, "Invalid address.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            DISETVALUE32(address.dlaLinAddress.v, g_nMemAddress);

            // Scan value from edit field
            GetDlgItemText(hDlg, IDC_VALUE, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &g_nMemValue) != 1)
            {
                MessageBox(NULL, "Invalid value.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            DISETVALUE32(value.dmValue, g_nMemValue);

            // Write the value to memory
            fRet = DiMemoryWrite(address, &value, 1);
            if (fRet != DI_OK)
            {
                MessageBox(NULL, "Error writing to memory.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            return TRUE;

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
