/////////////////////////////////////////////////////////////////////////////
// RegisterReadDlg.c

#include "Windows.h"
#include "GdiExample.h"

int g_nRegSel = 0;

BOOL CALLBACK RegisterReadDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
                                  LPARAM lParam)
{
    HWND hwndList;
    DiUInt32T nID;
    DiReturnT fRet;
    DiRegisterValueT value;
    int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:

        // Add registers to drop list
        hwndList = GetDlgItem(hDlg, IDC_REGISTERS);
        SendMessage(hwndList, CB_ADDSTRING, 0, (LPARAM)"PC");

        for (i = 0; i < NUM_REGISTERS; i++)
            SendMessage(hwndList, CB_ADDSTRING, 0, (LPARAM) g_registers[i].szRegName);

        SendMessage(hwndList, CB_SETCURSEL, g_nRegSel, 0);
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
        case IDC_READ:

            // Clear display
            FreeOutputLines();
            InvalidateRect(g_hMainWnd, NULL, TRUE);

            // Get current selection in register list
            hwndList = GetDlgItem(hDlg, IDC_REGISTERS);
            g_nRegSel = SendMessage(hwndList, CB_GETCURSEL, 0, 0);
            if (g_nRegSel == CB_ERR)
                return FALSE;

            // Map list index to register ID (note that PC is first in list)
            if (g_nRegSel == 0)
                nID = PC_ID;
            else
            {
                ASSERT(g_nRegSel <= NUM_REGISTERS);
                nID = g_registers[g_nRegSel - 1].dnRegNumber;
            }

            fRet = DiRegisterRead(nID, &value);
            if (fRet != DI_OK)
                MessageBox(NULL, "Error reading register.", "Error", MB_OK|MB_ICONSTOP);
            else
            {
                // Display value in output buffer
                g_outputLines[0] = malloc(20);
                sprintf(g_outputLines[0], "%X", DIVALUE32(value.dvValue));
            }
            
            return TRUE;

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
