/////////////////////////////////////////////////////////////////////////////
// RegisterWriteDlg.c

#include "Windows.h"
#include "GdiExample.h"

extern int g_nRegSel;
static int g_nRegValue = 0;

BOOL CALLBACK RegisterWriteDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								   LPARAM lParam)
{
    HWND hwndList;
    DiUInt32T nID;
    DiReturnT fRet;
    DiRegisterValueT value;
    char szTemp[20];
    int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
	
        // Add registers to drop list
        hwndList = GetDlgItem(hDlg, IDC_REGISTERS);
        SendMessage(hwndList, CB_ADDSTRING, 0, (LPARAM)"PC");

        for (i = 0; i < NUM_REGISTERS; i++)
            SendMessage(hwndList, CB_ADDSTRING, 0, (LPARAM) g_registers[i].szRegName);

        SendMessage(hwndList, CB_SETCURSEL, g_nRegSel, 0);
        itoa(g_nRegValue, szTemp, 16);
        SetDlgItemText(hDlg, IDC_VALUE, szTemp);
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDC_WRITE:

            // Get current selection in register list
            hwndList = GetDlgItem(hDlg, IDC_REGISTERS);
            g_nRegSel = SendMessage(hwndList, CB_GETCURSEL, 0, 0);
            if (g_nRegSel == CB_ERR)
                return FALSE;

            // Map list index to register ID (note that PC is first in list)
            if (g_nRegSel == 0)
                nID = PC_ID;
            else
            {
                ASSERT(g_nRegSel <= NUM_REGISTERS);
                nID = g_registers[g_nRegSel - 1].dnRegNumber;
            }

            // Scan value from edit control
            GetDlgItemText(hDlg, IDC_VALUE, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &g_nRegValue) == 1)
            {
                DISETVALUE32(value.dvValue, g_nRegValue);
                fRet = DiRegisterWrite(nID, value);
                if (fRet != DI_OK)
                    MessageBox(NULL, "Error writing to register.", "Error", MB_OK|MB_ICONSTOP);
            }
            else
                MessageBox(NULL, "Invalid value entered.", "Error", MB_OK|MB_ICONSTOP);
            
            return TRUE;

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
