/////////////////////////////////////////////////////////////////////////////
// RunContinueUntilDlg.c

#include "Windows.h"
#include "GdiExample.h"

BOOL CALLBACK RunContinueUntilDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								      LPARAM lParam)
{
    DiAddrT address;
    char szTemp[80];
    int nTemp = 0;
    DiReturnT fRet;

	switch (uMsg)
	{
	case WM_INITDIALOG:
	
        SetDlgItemText(hDlg, IDC_ADDRESS, "0");
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:

            // CODE memory space
            address.dmsMemSpace = CODE_ID;

            // Scan address
            GetDlgItemText(hDlg, IDC_ADDRESS, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &nTemp) != 1)
            {
                MessageBox(NULL, "Invalid address.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            DISETVALUE32(address.dlaLinAddress.v, nTemp);

            // Run
            fRet = DiExecContinueUntil(address);
            if (fRet != DI_OK)
            {
                MessageBox(NULL, "Execute command failed.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            // Fall through

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;

	}

	return FALSE;
}
