/////////////////////////////////////////////////////////////////////////////
// RunStepDlg.c

#include "Windows.h"
#include "GdiExample.h"

BOOL CALLBACK RunStepDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam,
								LPARAM lParam)
{
    int nSteps;
    char szTemp[20];
    DiReturnT fRet;

	switch (uMsg)
	{
	case WM_INITDIALOG:

        SetDlgItemText(hDlg, IDC_NUM_STEPS, "1");
		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
        case IDOK:

            // Scan number of steps entered
            GetDlgItemText(hDlg, IDC_NUM_STEPS, szTemp, sizeof(szTemp));
            if (sscanf(szTemp, "%x", &nSteps) != 1)
            {
                MessageBox(NULL, "Invalid number of steps.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            fRet = DiExecSingleStep(nSteps);
            if (fRet != DI_OK)
            {
                MessageBox(NULL, "Single step failed.", "Error", MB_OK|MB_ICONSTOP);
                return FALSE;
            }

            // Fall through

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return TRUE;
		}

		break;
	}

	return FALSE;
}
